#ifndef _HW3_H
#define _HW3_H

#define PATH_SIZE 255 /* maximum file path size */
#define IMG_SIZE 1022  /* maximum image size in either dimension */

typedef struct pixel {
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} pixelT;

/*
 * Loads a PPM image from a file to a 2D array in memory
 * and sets its dimensions and maximum color value
 *
 * Parameters: 
 *           filepath, where the image is located
 *           image, 2D array of struct pixel, initially empty
 *           p_width, the address of an integer that will hold the image width
 *           p_height, the address of an integer that will hold the image height
 *           p_maxcolor, the address of an integer that will hold the colors' max value
 * 
 * Returns: 
 *          1, if the image was successfully loaded
 *          0, otherwise
 */
int load_image(char *filepath, pixelT image[][IMG_SIZE], int *p_width, int *p_height, int *p_maxcolor);

/*
 * Saves a PPM image from a 2D array in memory to a file.
 *
 * Parameters: 
 *           filepath, where the image is to be saved
 *           image, 2D array of struct pixel
 *           width, the image width
 *           height, image height
 *           maxcolor, the colors' max value
 * 
 * Returns: 
 *          1, if the image was successfully saved
 *          0, otherwise
 */
int save_image(char *filepath, pixelT image[][IMG_SIZE], int width, int height, int maxcolor);

#endif
